"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
// tslint:disable-next-line:file-name-casing
const ora_1 = tslib_1.__importDefault(require("ora"));
const signale_1 = tslib_1.__importDefault(require("signale"));
// tslint:disable-next-line:no-unnecessary-class
class Logger {
    // uses signale for logging withoug thisRef
    // tslint:disable-next-line:no-unused
    static success(thisRef, message) {
        signale_1.default.success(`${message}`);
    }
    // tslint:disable-next-line:no-unused
    static info(thisRef, message) {
        signale_1.default.info(`${message}`);
    }
    static error(thisRef, message) {
        signale_1.default.error(`${message}`);
        thisRef.exit(0); //added to exit command
    }
    // tslint:disable-next-line:no-unused
    static warn(thisRef, message) {
        signale_1.default.warn(`${message}`);
    }
    // tslint:disable-next-line:no-unused
    static progressStart(thisRef, message) {
        // signale.watch(`${message}`)
        Logger.spinner = ora_1.default(message);
        Logger.spinner.start();
    }
    // tslint:disable-next-line:no-unused
    static progressStop(thisRef, message) {
        Logger.spinner.succeed(message);
    }
    // tslint:disable-next-line:no-unused
    static progressStopError(thisRef, message) {
        Logger.spinner.warn(message);
    }
}
exports.default = Logger;
//# sourceMappingURL=logger.js.map